namespace NXyn.Aux
    open System

    module ProcessMisc =
        let append_line_to_file (s:string) (filename:string) =
            let appendOK () =
                try 
                    use w = new IO.StreamWriter(filename, true)
                    w.WriteLine(s)
                    w.Close()
                    true
                with :? IO.IOException -> false    
            let mutable ntries = 1
            while not(appendOK()) do
                Threading.Thread.Sleep(1)
                ntries <- ntries + 1
            ntries


        (* generate temp file name *)
        (* does that create 2 files? *)
        (* obsolete *)
        let rec GetTempFileNameWithExtension (extension:string) =
            let s0 = IO.Path.GetTempFileName()
            let s = IO.Path.ChangeExtension(s0,extension)
            if not (IO.File.Exists(s)) then begin IO.File.Delete(s0); s end
            else GetTempFileNameWithExtension extension



        let string_of_args (args:string list) =
            let w = new IO.StringWriter()

            let isfirst = ref true
            for arg in args do
                if not !isfirst then w.Write(' ')
                isfirst := false
                let needs_quote = String.exists (fun (x:char) -> Char.IsWhiteSpace(x)) arg
                if needs_quote then w.Write('\"')
                w.Write(arg)
                if needs_quote then w.Write('\"')
            w.ToString()

        (* TBD might need escaping, too *)
        let invoke_with_args (logfile:string) (progname:string) (args:string list) =
            let arg_str = string_of_args(args)

            let pi = new Diagnostics.ProcessStartInfo(progname,arg_str)
            pi.CreateNoWindow <- true
            let p = new Diagnostics.Process()
            p.StartInfo <- pi
            p.Start() |> ignore
            p.WaitForExit()
  
            let exitcode = p.ExitCode
//            append_line_to_file (sprintf "called %s '%s', exitcode %d" progname arg_str exitcode) logfile |> ignore
            exitcode (* if exitcode <> 0 then failwithf "exitcode %d" exitcode *)

        let PId = System.Diagnostics.Process.GetCurrentProcess().Id

