namespace NXyn.EmitFSharp

  open System
  open NXyn.EmitFSharp.Common
  
  module DispatchUnion =

    open Microsoft.FSharp.Reflection

    let OutputCode (w:System.CodeDom.Compiler.IndentedTextWriter) (t:System.Type) (argidx:int) (methodname0:string) assemblemethodname (name:string) =
      if t.ContainsGenericParameters then failwith "EmitFSharpDispatchUnion.OutputCode: open types unsupported"
      if argidx < 0 then failwith "EmitFSharpDispatchUnion: invalid argument index"

      w.WriteLine("let {0} = function", name)
      w.Indent <- w.Indent + 1

      let tShortName = ClippedFSharpTypeName t.Name
      for (uc:UnionCaseInfo) in FSharpType.GetUnionCases t do
        let n = (uc.GetFields ()).Length
        if argidx >= n then failwith "EmitFSharpDispatchUnion.OutputCode: argument index out of range"
        WriteList w ("| " + tShortName + "." + uc.Name + "(")  "," ") -> " n (fun i -> "a" + string i)
        let methodname = ref methodname0
    (*
        let fields = uc.GetFields ()
        for i = 0 to fields.Length - 1 do
          if i <> argidx then
            methodname := !methodname + "_" + fields.[i].PropertyType.Name
    *)
        WriteListLine w ("a" + string argidx + "." + !methodname + " ") "" "" n (fun i -> if i = argidx then "" else "a" + string i + " ")

      w.Indent <- w.Indent - 1
      w.WriteLine(";;\n")
