namespace NXyn.EmitFSharp

  open System
  open NXyn.EmitFSharp.Common
  open System.Reflection
  open Microsoft.FSharp.Reflection

  module IsEqualUnion =
    let OutputCode (w:System.CodeDom.Compiler.IndentedTextWriter) (t1:System.Type) (t2:System.Type) (name:string) =
      if t1.ContainsGenericParameters || t2.ContainsGenericParameters then failwith "EmitFSharpShallowMapper.OutputCode: open types unsupported"
      w.WriteLine("let {0} (a1 : {1}) (a2 : {2}) : bool =", name, FSharpTypeName t1, FSharpTypeName t2)
      w.Indent <- w.Indent + 1
      w.WriteLine("match (a1,a2) with")
      w.Indent <- w.Indent + 1

      let (t1ShortName,t2ShortName) = (ClippedFSharpTypeName t1.Name, ClippedFSharpTypeName t2.Name)
      let (t1Cases,t2Cases) = (FSharpType.GetUnionCases t1, FSharpType.GetUnionCases t2)
      for (uc:UnionCaseInfo) in Array.filter (fun (uc:UnionCaseInfo) -> Array.exists (UnionCaseInfo_equal uc) t2Cases) t1Cases do
        match uc.GetFields () with
          | [||] -> w.WriteLine("| ({0}.{2}, {1}.{2}) -> true", t1ShortName, t2ShortName, uc.Name)
          | fs ->
              WriteList     w ("| (" + t1ShortName + "." + uc.Name + "(")  "," "), " fs.Length (fun i -> "a" + string i)
              WriteList     w (t2ShortName + "." + uc.Name + "(") "," ")) -> " fs.Length (fun i -> "b" + string i)
              WriteListLine w "" " && " "" fs.Length (fun i -> "a" + string i + "=" + "b" + string i)

      w.WriteLine("| _ -> false")
      w.Indent <- w.Indent - 2
      w.WriteLine(";;\n")
