module PPrint

open NXyn.JSON

let main(args:string []) =
    let style = if   Array.exists((=)"--print")       args then OutputStyle.Print
                elif Array.exists((=)"--compact")     args then OutputStyle.Compact
                elif Array.exists((=)"--format")      args then OutputStyle.Format
                elif Array.exists((=)"--printjagged") args then OutputStyle.PrintJagged
                                                           else OutputStyle.Default
    let input_opts  = InputOptions.Default.Set(args)
    let output_opts = OutputOptions.Default.Set(args)
    Value.Read(input_opts).WriteLine(style, output_opts)

main(System.Environment.GetCommandLineArgs())
