module Lifespans
(*
 * Copyright (c) 2007-2008, 2009, 2010 Stefan Kral
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *)


open NXyn.Aux

(* Rename stack-cells to maximize reuse of the ones with the lowest indices *)



(*
let select_first p =
  let rec loop pre' = function
    | [] -> None
    | x::xs -> if p x then Some(pre',x,xs) else loop (x::pre') xs
  in fun xs -> loop [] xs
*)
(* => MISC already present? *)
(*
let select_first' =
  let rec loop f pre' = function
    | [] -> None
    | x::xs ->
        let res = f pre' x xs
        in if res = None then loop f (x::pre') xs else res
  in fun f xs -> loop f [] xs
*)
(* => MISC already present? *)
(*
let rec rev_append l1 l2 =
                   match l1
                    with | [] -> l2
                         | h::t -> rev_append t (h::l2)
*)
(*
let max_pressure =
  let rec merge_lifespans (ls:((int * int) * int) list) (rs:((int * int) * int) list) =
    match (ls,rs) with
      | ([],xs) | (xs,[]) -> xs
      | ((((f_x,t_x),n_x) as x)::xs, (((f_y,t_y),n_y) as y)::ys) ->
          if t_x < f_y then x::(merge_lifespans xs rs) 
          else if t_y < f_x then y::(merge_lifespans ls ys) 
          else 
            if      f_x < f_y then ((f_x,f_y-1),n_x)::(merge_lifespans (((f_y,t_x),n_x)::xs) rs)
            else if f_x > f_y then ((f_y,f_x-1),n_y)::(merge_lifespans ls (((f_x,t_y),n_y)::ys))
            else
              let n_xy = n_x+n_y
              if      t_x < t_y then ((f_x,t_x),n_xy)::(merge_lifespans xs (((t_x+1,t_y),n_y)::ys))
              else if t_x > t_y then ((f_y,t_y),n_xy)::(merge_lifespans (((t_y+1,t_x),n_x)::xs) ys)
              else ((f_x,t_x),n_xy)::(merge_lifespans xs ys)
  let rec overlay_lifespans' = function
    | [] -> []
    | _::_ as xs ->
        let (ys,zs) = zigzag xs
        merge_lifespans (overlay_lifespans' ys) (overlay_lifespans' zs)
  let overlay_lifespans xs = overlay_lifespans' (List.map (fun x -> (x,1)) xs)
  fun (ls:(int * int) list) -> List.fold (fun n0 (_,n) -> max n n0) 0 (overlay_lifespans ls)
*)

(***)

let non_overlapping (_,_,(a1,z1)) (_,_,(a2,z2)) = z1 < a2 || z2 < a1
let spans_nonoverlapping spans span = List.forall (non_overlapping span) spans
    
let larger_than (_,n1,(a1,z1)) (_,n2,(a2,z2)) = n1 >= n2 && (z1-a1) > (z2-a2) // > 
//let larger_than (_,_,(a1,z1)) (_,_,(a2,z2)) = (z1-a1) > (z2-a2) // > 

let sort_ascending (ls:list<int * int * (int * int)>) = List.sortWith (fun (_,_,(a1,z1)) (_,_,(a2,z2)) -> z1-a1-(z2-a2)) ls

//let keysort_ascending xs = List.sortBy fst xs
//let keysort xs = keysort_ascending xs

(*
let lifeSpans_of_defUses defUses = 
  let collect cell ts ls = ((cell,(List.min ts,List.max ts))::ls)
  let add_defUse (t,map) cells = (t+1,List.fold (fun map cell -> Map.add cell (t::(defaultArg (Map.tryFind cell map) [])) map) map cells)
  let (_,map) = List.fold add_defUse (1,Map.empty) defUses
  Map.foldBack collect map []
*)
let join_lifespans ls =
  let rec improve thisSpans restSpans =
    match 
      ListMisc.select_first' 
        (fun preThisSpans thisSpan postThisSpans ->
           ListMisc.select_first'
             (fun pre_remSpans remSpan post_remSpans ->
                if not (larger_than remSpan thisSpan && spans_nonoverlapping preThisSpans remSpan && spans_nonoverlapping postThisSpans remSpan) then None
                else Some(remSpan::(preThisSpans @ postThisSpans), thisSpan::(pre_remSpans @ post_remSpans)))
             restSpans)
        thisSpans with
      | None -> (thisSpans,sort_ascending restSpans)
      | Some(thisSpans',restSpans') -> improve thisSpans' restSpans' 

  and join doneSpans thisSpans = function
    | [] -> if thisSpans = [] then doneSpans else (thisSpans::doneSpans)
    | restSpans ->
        match ListMisc.select_first' (fun pre' span post -> if spans_nonoverlapping thisSpans span then Some(pre',span,post) else None) restSpans with
          | None ->
              let (thisSpans',restSpans') = improve thisSpans restSpans
              join (thisSpans'::doneSpans) [] restSpans'
          | Some(pre',span,post) ->
              join doneSpans (span::thisSpans) (ListMisc.rev_append pre' post)



//  let t0 = System.DateTime.Now
  let lss = join [] [] (sort_ascending ls)

//  let keysort_ascending xs = List.sortBy fst xs
//  let keysort xs = keysort_ascending xs

  let lss = List.sortBy (fun spans -> spans |> List.map (fun (_,n,_) -> n) |> List.sum |> (~-)) lss // List.length >> (~-)) lss
  let lss = List.fold (fun (ix,spans) xs -> (ix+1,(ix,xs)::spans)) (1,[]) lss
  let result = lss |> snd |> List.rev

//  let lss = keysort (List.map (fun xs -> (List.length xs,xs)) lss) // ACKWARD -> use ResizeArray...
//  let lss = List.rev (List.map snd lss)
  
//  let annotate (t,spans) xs = (t+1,(t,xs)::spans) 
//  let result = List.rev (snd (List.fold annotate (1,[]) lss))
//  let t1 = System.DateTime.Now
//  eprintfn "lifespans: %A" (t1 - t0)
  result


(*
let map_of_joinedLifeSpans ls =
  let add_span_to_map map (d,spans) = List.fold (fun map (s,_) -> Map.add s d map) map spans
  List.fold add_span_to_map Map.empty ls
*)
(***)

(*
open X64instr
*)
(* need stack-in-out data of this block *)
(*
open System
open System.Collections.Generic

open InstrIO
open MoreInstrIO
*)
(*
let rename_stackcells (instrs0:Instr list) =
  let nDefuses = new Dictionary<Int32, Int32>()
  let incrNdefuses(i:Int32) = nDefuses.[i] <- 1 + (match nDefuses.TryGetValue(i) with (true,n0) -> n0 | (false,_) -> 0)


  let defUses = List.map (fun (i:Instr) ->
                             let d  = Md_of_Instr(i)  |> List.choose (fun(size,m) -> match m with EA64(IexprInt32(i), Some{Base=r}, None) when r=R64.rsp -> Some(i) | _ -> None)
                             let ds = Mds_of_Instr(i) |> List.choose (fun(size,m) -> match m with EA64(IexprInt32(i), Some{Base=r}, None) when r=R64.rsp -> Some(i) | _ -> None)
                             let s  = Ms_of_Instr(i)  |> List.choose (fun(size,m) -> match m with EA64(IexprInt32(i), Some{Base=r}, None) when r=R64.rsp -> Some(i) | _ -> None)
                             let all = d @ ds @ s
                             all |> List.iter incrNdefuses
                             all
                          ) instrs0
  let ls = lifeSpans_of_defUses defUses
//  let maxpressure = max_pressure (List.map snd ls)
  let ls' = join_lifespans ls

  ls'
  |> List.partition (fun(i,_) -> i <= 16)
  |> fun(yes,no) ->
       let yes = yes |> List.map (snd >> List.length) |> List.sum
       let no  = no  |> List.map (snd >> List.length) |> List.sum
       eprintfn "   yes = %d, all = %d, ratio = %f" yes (yes+no) (100.0 * (float yes) / (float (yes + no)))
       for KeyValue(ix,n) in nDefuses do
           eprintfn "    ix=%d   ndefsuses=%d" ix n
       eprintfn "   all rename_stackcells: %A" ls'

       
       ()
*)

(*  Printf.printf "maxpressure = %A" maxpressure *)
(*  Printf.printfn "ls  (%d) = %A" ls.Length  ls
  Printf.printfn "ls' (%d) = %A" ls'.Length ls'
 *)
(*
  let map = map_of_joinedLifeSpans ls' in
*)


(*
  let map_stackcell =
    Instr.map_vecStackCell_in_memop (fun k -> Basics.IntMap.find k map) in
  let map_aInstr (instr,anno) =
    (Instr.map_memop_in_vecinstr map_stackcell instr,anno) in
  let aInstrs = List.map map_aInstr aInstrs0 in

  let () =
    Dump.print_fn 10 
      (fun () ->
	 Printf.sprintf "VecStackReuse: %d -> %d (maxpressure %d)" 
	   (List.length ls) (List.length ls') maxpressure) in
  let dump_data () =
    List.iter 
      (fun k ->
	 let first_k = Basics.take_atmost k ls'
	 in Dump.print 50 
	      (Printf.sprintf "VecStackReuse: #cells in first %d = %d" k
		 (List.length (List.flatten (List.map snd first_k)))))
      [16;32;48;64;80;96] in
  let () = Dump.maybe_fn 50 dump_data
  in aInstrs

let vstackreuse_procedure p = 
  Instr.map_aInstrs_in_procedure vstackreuse_aInstrs p
*)
